/*
 * grph2_uipack.fp
 *
 * $Id: grph2_uipack.fp,v 1.3 2012-03-08 05:16:17 koshiro Exp $
 */

#if DCLVER >= 544

/*****************************************************
 * grph2/uipack/uipdat.f
 ****************************************************/
/* 
 *      SUBROUTINE UIPDAT(Z, MX, NX, NY)
 *      REAL      Z(MX,*)
 */
      SUBROUTINE UIPDAT(
          REAL (MX,NY) Z
          INTEGER MX
          INTEGER NX
          INTEGER NY
      )

/*****************************************************
 * grph2/uipack/uipda2.f
 ****************************************************/
/* 
 *      SUBROUTINE UIPDA2(U, V, MX, NX, NY)
 *      REAL      U(MX, *), V(MX, *)
 */
      SUBROUTINE UIPDA2(
          REAL (MX,NY) U
          REAL (MX,NY) V
          INTEGER MX
          INTEGER NX
          INTEGER NY
      )

/*****************************************************
 * grph2/uipack/uipda3.f
 ****************************************************/
/* 
 *      SUBROUTINE UIPDA3(U, V, W, MX, NX, NY)
 *      REAL      U(MX, *), V(MX, *), W(MX, *)
 */
      SUBROUTINE UIPDA3(
          REAL (MX,NY) U
          REAL (MX,NY) V
          REAL (MX,NY) W
          INTEGER MX
          INTEGER NX
          INTEGER NY
      )

/*****************************************************
 * grph2/uipack/uicrgb.f
 ****************************************************/
/* 
 *      ENTRY UISCRG(ZMIN, ZMAX)
 */
      SUBROUTINE UISCRG(
          REAL ZMIN
          REAL ZMAX
      )

/* 
 *      ENTRY UISMRG(ZMIN, ZMAX)
 */
      SUBROUTINE UISMRG(
          REAL ZMIN
          REAL ZMAX
      )

/* 
 *      ENTRY UISCSQ(CLRLVL, ICOLOR, N)
 *      DIMENSION ICOLOR(*), CLRLVL(*)
 */
      SUBROUTINE UISCSQ(
          REAL (N) CLRLVL
          INTEGER (N) ICOLOR
          INTEGER N
      )

/* 
 *      ENTRY UISCFL(CDSN)
 *      CHARACTER CDSN*(*)
 */
      SUBROUTINE UISCFL(
          CHARACTER*(*) CDSN
      )

/* 
 *      ENTRY UISMSQ(SHDLVL, SHADE, N)
 *      DIMENSION SHADE(*), SHDLVL(*)
 */
      SUBROUTINE UISMSQ(
          REAL (N) SHDLVL
          INTEGER (N) SHADE
          INTEGER N
      )

/* 
 *      ENTRY UISMFL(CDSN)
 *      CHARACTER CDSN*(*)
 */
      SUBROUTINE UISMFL(
          CHARACTER*(*) CDSN
      )

/*****************************************************
 * grph2/uipack/uixbar.f
 ****************************************************/
/* 
 *      SUBROUTINE UIXBAR(XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,CPOS)
 *      CHARACTER CPOS*(*)
 */
      SUBROUTINE UIXBAR(
          REAL XMIN
          REAL XMAX
          REAL YMIN
          REAL YMAX
          REAL ZMIN
          REAL ZMAX
          CHARACTER*(*) CPOS
      )

/*****************************************************
 * grph2/uipack/uiybar.f
 ****************************************************/
/* 
 *      SUBROUTINE UIYBAR(XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,CPOS)
 *      CHARACTER CPOS*(*)
 */
      SUBROUTINE UIYBAR(
          REAL XMIN
          REAL XMAX
          REAL YMIN
          REAL YMAX
          REAL ZMIN
          REAL ZMAX
          CHARACTER*(*) CPOS
      )

/*****************************************************
 * grph2/uipack/uic2d.f
 ****************************************************/
/* 
 *      ENTRY UISCR2(UMIN, UMAX, VMIN, VMAX)
 */
      SUBROUTINE UISCR2(
          REAL UMIN
          REAL UMAX
          REAL VMIN
          REAL VMAX
      )

/* 
 *      ENTRY UIQCR2(UMIN, UMAX, VMIN, VMAX)
 */
      SUBROUTINE UIQCR2(
          REAL o UMIN
          REAL o UMAX
          REAL o VMIN
          REAL o VMAX
      )

/* 
 *      ENTRY UISCMP(IRGB1, IRGB2, IRGB3, IRGB4)
 */
      SUBROUTINE UISCMP(
          INTEGER IRGB1
          INTEGER IRGB2
          INTEGER IRGB3
          INTEGER IRGB4
      )

/*****************************************************
 * grph2/uipack/uipcmp.f
 ****************************************************/
/* 
 *      SUBROUTINE UIPCMP(XMIN,XMAX,YMIN,YMAX,CPOS)
 *      CHARACTER*(*) CPOS
 */
      SUBROUTINE UIPCMP(
          REAL XMIN
          REAL XMAX
          REAL YMIN
          REAL YMAX
          CHARACTER*(*) CPOS
      )

/*****************************************************
 * grph2/uipack/uifpac.f
 ****************************************************/
/* 
 *      SUBROUTINE UIFPAC(IR, IG, IB, IRGB)
 */
      SUBROUTINE UIFPAC(
          INTEGER IR
          INTEGER IG
          INTEGER IB
          INTEGER o IRGB
      )

/* 
 *      ENTRY UIIPAC(IRGB, IR, IG, IB)
 */
      SUBROUTINE UIIPAC(
          INTEGER IRGB
          INTEGER o IR
          INTEGER o IG
          INTEGER o IB
      )

/*****************************************************
 * grph2/uipack/uiiget.f
 ****************************************************/
/* 
 *      SUBROUTINE UIIGET(CP, IPARA)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIIGET(
          CHARACTER*(*) CP
          INTEGER o IPARA
      )

/* 
 *      ENTRY UIISET(CP, IPARA)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIISET(
          CHARACTER*(*) CP
          INTEGER IPARA
      )

/* 
 *      ENTRY UIISTX(CP, IPARA)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIISTX(
          CHARACTER*(*) CP
          INTEGER IPARA
      )

/*****************************************************
 * grph2/uipack/uiiqnp.f
 ****************************************************/
/* 
 *      SUBROUTINE UIIQNP(NCP)
 */
      SUBROUTINE UIIQNP(
          INTEGER o NCP
      )

/* 
 *      ENTRY UIIQID(CP, IDX)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIIQID(
          CHARACTER*(*) CP
          INTEGER o IDX
      )

/* 
 *      ENTRY UIIQCP(IDX, CP)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIIQCP(
          INTEGER IDX
          CHARACTER*(*) o CP
      )

/* 
 *      ENTRY UIIQCL(IDX, CP)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIIQCL(
          INTEGER IDX
          CHARACTER*(*) o CP
      )

/* 
 *      ENTRY UIIQVL(IDX, IPARA)
 */
      SUBROUTINE UIIQVL(
          INTEGER IDX
          INTEGER o IPARA
      )

/* 
 *      ENTRY UIISVL(IDX, IPARA)
 */
      SUBROUTINE UIISVL(
          INTEGER IDX
          INTEGER IPARA
      )

/* 
 *      ENTRY UIIQIN(CP, IN)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIIQIN(
          CHARACTER*(*) CP
          INTEGER o IN
      )

/*****************************************************
 * grph2/uipack/uilget.f
 ****************************************************/
/* 
 *      SUBROUTINE UILGET(CP, LPARA)
 *      CHARACTER CP*(*)
 *      LOGICAL   LPARA
 */
      SUBROUTINE UILGET(
          CHARACTER*(*) CP
          LOGICAL o LPARA
      )

/* 
 *      ENTRY UILSET(CP, LPARA)
 *      CHARACTER CP*(*)
 *      LOGICAL   LPARA
 */
      SUBROUTINE UILSET(
          CHARACTER*(*) CP
          LOGICAL LPARA
      )

/* 
 *      ENTRY UILSTX(CP, LPARA)
 *      CHARACTER CP*(*)
 *      LOGICAL   LPARA
 */
      SUBROUTINE UILSTX(
          CHARACTER*(*) CP
          LOGICAL LPARA
      )

/*****************************************************
 * grph2/uipack/uilqnp.f
 ****************************************************/
/* 
 *      SUBROUTINE UILQNP(NCP)
 */
      SUBROUTINE UILQNP(
          INTEGER o NCP
      )

/* 
 *      ENTRY UILQID(CP, IDX)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UILQID(
          CHARACTER*(*) CP
          INTEGER o IDX
      )

/* 
 *      ENTRY UILQCP(IDX, CP)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UILQCP(
          INTEGER IDX
          CHARACTER*(*) o CP
      )

/* 
 *      ENTRY UILQCL(IDX, CP)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UILQCL(
          INTEGER IDX
          CHARACTER*(*) o CP
      )

/* 
 *      ENTRY UILQVL(IDX, LPARA)
 *      LOGICAL   LPARA
 */
      SUBROUTINE UILQVL(
          INTEGER IDX
          LOGICAL o LPARA
      )

/* 
 *      ENTRY UILSVL(IDX, LPARA)
 *      LOGICAL   LPARA
 */
      SUBROUTINE UILSVL(
          INTEGER IDX
          LOGICAL LPARA
      )

/* 
 *      ENTRY UILQIN(CP, IN)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UILQIN(
          CHARACTER*(*) CP
          INTEGER o IN
      )

/*****************************************************
 * grph2/uipack/uirget.f
 ****************************************************/
/* 
 *      SUBROUTINE UIRGET(CP, RPARA)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIRGET(
          CHARACTER*(*) CP
          REAL o RPARA
      )

/* 
 *      ENTRY UIRSET(CP, RPARA)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIRSET(
          CHARACTER*(*) CP
          REAL RPARA
      )

/* 
 *      ENTRY UIRSTX(CP, RPARA)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIRSTX(
          CHARACTER*(*) CP
          REAL RPARA
      )

/*****************************************************
 * grph2/uipack/uirqnp.f
 ****************************************************/
/* 
 *      SUBROUTINE UIRQNP(NCP)
 */
      SUBROUTINE UIRQNP(
          INTEGER o NCP
      )

/* 
 *      ENTRY UIRQID(CP, IDX)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIRQID(
          CHARACTER*(*) CP
          INTEGER o IDX
      )

/* 
 *      ENTRY UIRQCP(IDX, CP)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIRQCP(
          INTEGER IDX
          CHARACTER*(*) o CP
      )

/* 
 *      ENTRY UIRQCL(IDX, CP)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIRQCL(
          INTEGER IDX
          CHARACTER*(*) o CP
      )

/* 
 *      ENTRY UIRQVL(IDX, RPARA)
 */
      SUBROUTINE UIRQVL(
          INTEGER IDX
          REAL o RPARA
      )

/* 
 *      ENTRY UIRSVL(IDX, RPARA)
 */
      SUBROUTINE UIRSVL(
          INTEGER IDX
          REAL RPARA
      )

/* 
 *      ENTRY UIRQIN(CP, IN)
 *      CHARACTER CP*(*)
 */
      SUBROUTINE UIRQIN(
          CHARACTER*(*) CP
          INTEGER o IN
      )

/*****************************************************
 * grph2/uipack/uiqfnm.f
 ****************************************************/
/* 
 *      SUBROUTINE UIQFNM(CPARA,CFNAME)
 *      CHARACTER CPARA*(*),CFNAME*(*)
 */
      SUBROUTINE UIQFNM(CPARA,CFNAME)
          CHARACTER*(*) CPARA
          CHARACTER*(*) o CFNAME
      )

#endif

