/*
 * $Id: p_header,v 1.2 2011-02-23 17:47:10 koshiro Exp $
 */

#include <stdio.h>
#include "ruby.h"
#include "libtinyf2c.h"
#include "narray.h"

/* for compatibility with ruby 1.6 */
#ifndef StringValuePtr
#define StringValuePtr(s) STR2CSTR(s)
#endif

#define DFLT_SIZE 32

extern char    *dcl_obj2ccharary(VALUE, int, int);
extern integer *dcl_obj2cintegerary(VALUE);
extern real    *dcl_obj2crealary(VALUE);
extern complex *dcl_obj2ccomplexary(VALUE);
extern logical *dcl_obj2clogicalary(VALUE);

extern VALUE dcl_ccharary2obj(char *, int, int);
extern VALUE dcl_cintegerary2obj(integer *, int, int, int *);
extern VALUE dcl_crealary2obj(real *, int, int, int *);
extern VALUE dcl_ccomplexary2obj(complex *, int, char *);
extern VALUE dcl_clogicalary2obj(logical *, int, int, int *);

extern void dcl_freeccharary(char *);
extern void dcl_freecintegerary(integer *);
extern void dcl_freecrealary(real *);
extern void dcl_freeccomplexary(complex *);
extern void dcl_freeclogicalary(logical *);

/* for functions which return real */
/* fnclib */
extern real rd2r_(real *);
extern real rr2d_(real *);
extern real rexp_(real *, integer *, integer *);
extern real rfpi_(void);
extern real rmod_(real *, real *);
/* gnmlib */
extern real rgnlt_(real *);
extern real rgnle_(real *);
extern real rgngt_(real *);
extern real rgnge_(real *);
/* rfalib */
extern real rmax_(real *, integer *, integer *);
extern real rmin_(real *, integer *, integer *);
extern real rsum_(real *, integer *, integer *);
extern real rave_(real *, integer *, integer *);
extern real rvar_(real *, integer *, integer *);
extern real rstd_(real *, integer *, integer *);
extern real rrms_(real *, integer *, integer *);
extern real ramp_(real *, integer *, integer *);
/* rfblib */
extern real rprd_(real *, real *, integer *, integer *, integer *);
extern real rcov_(real *, real *, integer *, integer *, integer *);
extern real rcor_(real *, real *, integer *, integer *, integer *);


extern VALUE mDCL;

static VALUE
dcl_ifromc(obj, cx)
    VALUE obj, cx;
{
    char *i_cx;
    integer o_rtn_val;
    VALUE rtn_val;

    if (TYPE(cx) != T_STRING) {
      cx = rb_funcall(cx, rb_intern("to_str"), 0);
    }

    i_cx = StringValuePtr(cx);


    o_rtn_val = ifromc_(i_cx, (ftnlen)strlen(i_cx));

    rtn_val = INT2NUM(o_rtn_val);


    return rtn_val;

}

static VALUE
dcl_lfromc(obj, cx)
    VALUE obj, cx;
{
    char *i_cx;
    logical o_rtn_val;
    VALUE rtn_val;

    if (TYPE(cx) != T_STRING) {
      cx = rb_funcall(cx, rb_intern("to_str"), 0);
    }

    i_cx = StringValuePtr(cx);


    o_rtn_val = lfromc_(i_cx, (ftnlen)strlen(i_cx));

    rtn_val = (o_rtn_val == FALSE_) ? Qfalse : Qtrue;


    return rtn_val;

}

static VALUE
dcl_rfromc(obj, cx)
    VALUE obj, cx;
{
    char *i_cx;
    real o_rtn_val;
    VALUE rtn_val;

    if (TYPE(cx) != T_STRING) {
      cx = rb_funcall(cx, rb_intern("to_str"), 0);
    }

    i_cx = StringValuePtr(cx);


    o_rtn_val = rfromc_(i_cx, (ftnlen)strlen(i_cx));

    rtn_val = rb_float_new((double)o_rtn_val);


    return rtn_val;

}
void
init_math1_xfclib(mDCL)
VALUE mDCL;
{
    rb_define_module_function(mDCL, "ifromc", dcl_ifromc, 1);
    rb_define_module_function(mDCL, "lfromc", dcl_lfromc, 1);
    rb_define_module_function(mDCL, "rfromc", dcl_rfromc, 1);
}
